// rain
#ifdef OPENGL_ES
#extension GL_OES_standard_derivatives : enable
#ifdef GL_FRAGMENT_PRECISION_HIGH
precision highp float;
#else
precision mediump float;
#endif
#else
precision mediump float;
#endif

// Uniforms
uniform sampler2D u_texture;
uniform float u_time;
uniform vec3 u_resolution;

// Varyings
varying vec2 v_texCoord;

void main()
{
	vec2 uv = gl_FragCoord.xy / u_resolution.xy;
	uv *= 1000.0;
	float a = (uv.y * 0.001 + uv.x * 0.9);
	float b = fract(uv.x * 0.61);
	float c = 1.0 - fract((a * b) + u_time) * 300.0;
	vec4 t = texture2D(u_texture, v_texCoord);
	t += clamp(c, 0.0, 1.0);
	gl_FragColor = vec4(t.rgb, 1.0);
}
