// snow
#ifdef OPENGL_ES
#extension GL_OES_standard_derivatives : enable
#ifdef GL_FRAGMENT_PRECISION_HIGH
precision highp float;
#else
precision mediump float;
#endif
#else
precision mediump float;
#endif

// Uniforms
uniform sampler2D u_texture;
uniform float u_time;
uniform vec3 u_resolution;

// Varyings
varying vec2 v_texCoord;

float hash(float p)
{
	p = fract(p * 0.1031);
	p *= p + 33.33;
	p *= p + p;
	return fract(p);
}

float snow(vec2 p)
{
	float t = u_time;
	float l = 0.0;
	for (float i = 0.0; i < 100.0; i += 1.0) {
		float z = hash(i * 0.1);
		float depth = mix(200.0, 50.0, z * z);
		float invDepth = 1.0 / depth;
		float wave = sin(t * 2.0 + i);
		//vec2 pos = (fract(vec2(hash(i * 0.2), hash(i * 0.3)) + (50.0 * u_resolution.y - t * vec2(50.0, 10.0) + vec2(0.0, wave * 10.0)) / vec2(4.0,2.2) * invDepth) - 0.5) * vec2(4.0, 2.2);
		vec2 pos = (fract(vec2(hash(i * 0.2), hash(i * 0.3)) + ( -t * vec2(2.0, 50.0) + vec2(wave * 10.0, wave * 10.0)) / vec2(4.0, 2.2) * invDepth) - 0.5) * vec2(4.0, 2.2);
		l += sqrt(depth / 150.0) * smoothstep(-0.01, 0.01, invDepth - length(p - pos)) * (1.0 - l);
	}
	return l;
}

void main()
{
	vec2 p = (2.0 * gl_FragCoord.xy - u_resolution.xy) / u_resolution.y;
	vec3 col = vec3(snow(p));
	vec3 c = texture2D(u_texture, v_texCoord).xyz;
	c += clamp(col, 0.0, 1.0);
	gl_FragColor = vec4(c, 1.0);
}
