#ifdef OPENGL_ES
precision highp float;
#endif

uniform sampler2D u_diffuseTexture;		// Diffuse map texture

varying vec3 o_vNml;
varying vec2 o_vUV;				// Texture coordinate
varying vec3 o_vEye;

// lightdir
const vec3 vLight = vec3(0.5, 1.0, 0.5);
// fog
const float fNear = 0.0;
//const float fFar = 50.0;
uniform vec3 u_pointLightColor[10];

mat3 rgb2c = mat3(
	0.80, 0.20, 0.10,
	0.20, 0.80, 0.10,
	0.20, 0.20, 0.80
);

void main()
{
	float fFar = u_pointLightColor[1].r * 100.0;

	vec3 N = normalize(o_vNml);
	vec3 L = normalize(vLight);
	vec3 E = normalize(o_vEye);

	float F = dot(N, L);
	F = F * 0.5 + 0.5;
	F = F * F;
	F = F + 0.5;

	N = normalize(reflect(-L, N));

	vec4 C = texture2D(u_diffuseTexture, o_vUV);
	float A = C.w;

	//C = C * F;
	//C = C * F + vec4(1.0, 1.0, 1.0, 0.0) * pow(max(dot(N, E), 0.0), 8.0);
	C = C * F + pow(max(dot(N, E), 0.0), 8.0);

// fog
	float F1 = (fFar - (gl_FragCoord.z / gl_FragCoord.w)) / (fFar - fNear);
	F1 = clamp(F1, 0.0, 1.0);
	C = C * F1 + vec4(u_pointLightColor[0], 1.0) * (1.0 - F1);

	vec3 col = rgb2c * C.xyz;

	//C.r = C.r - ((C.r - 0.5) * 0.3125);
	//C.g = C.g - ((C.g - 0.5) * 0.3125);
	//C.b = C.b - ((C.b - 0.5) * 0.3125);
/*
	float r = (C.r - 0.5) * 12.649;
	r *= r;
	float g = (C.g - 0.5) * 12.649;
	g *= g;
	float b = (C.r - 0.5) * 12.649;
	b *= b;

	C.r = C.r - (r * 0.00392);
	C.g = C.g - (g * 0.00392);
	C.b = C.b - (b * 0.00392);
*/
	gl_FragColor = vec4(col, A);
}
